﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using BarSeriesDemo.Annotations;

namespace BarSeriesDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<ChartData> data;

        public ViewModel()
        {
                
        }

        public ObservableCollection<ChartData> Data => data ?? (data = LoadData());
        
        public double ChartMinimum { get; set; } = 0;

        public double ChartMaximum { get; set; } = 10;

        public double CurrentStep { get; set; } = 1;

        public object AnnotationValue { get; set; } = 5;

        public string AnnotationLabel { get; set; } = "Annotation here";

        public bool IsAbsoluteBarChartVisible { get; set; } = true;

        #region boilerplate

        private ObservableCollection<ChartData> LoadData()
        {
            var list = new ObservableCollection<ChartData>();
            for (int i = 0; i < 10; i++)
            {
                list.Add(new ChartData { Category = $"Cat {i}", Value = i });
            }
            return list;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        
        #endregion
    }

    public class ChartData
    {
        public string Category { get; set; }
        public double Value { get; set; }
    }
}
